import { AnnotationType, Facet, Transaction, StateEffect, Extension, StateCommand, EditorState } from '@codemirror/state';
import { KeyBinding } from '@codemirror/view';

declare const isolateHistory: AnnotationType<"before" | "after" | "full">;
declare const invertedEffects: Facet<(tr: Transaction) => readonly StateEffect<any>[], readonly ((tr: Transaction) => readonly StateEffect<any>[])[]>;
interface HistoryConfig {
    minDepth?: number;
    newGroupDelay?: number;
}
declare function history(config?: HistoryConfig): Extension;
declare const undo: StateCommand;
declare const redo: StateCommand;
declare const undoSelection: StateCommand;
declare const redoSelection: StateCommand;
declare const undoDepth: (state: EditorState) => number;
declare const redoDepth: (state: EditorState) => number;
declare const historyKeymap: readonly KeyBinding[];

export { history, historyKeymap, invertedEffects, isolateHistory, redo, redoDepth, redoSelection, undo, undoDepth, undoSelection };
